#property indicator_chart_window
#property indicator_buffers 6
#property indicator_color1 Red 
#property indicator_color2 Red 
#property indicator_color3 Green
#property indicator_color4 Green
#property indicator_color5 Blue
#property indicator_color6 Blue

extern int  Period1            = 12;
extern int  Period2            = 55;
extern int  Period3            = 122;
extern bool alertsOn           = false;
extern bool alertsOnCurrent    = true;
extern bool alertsMessage      = true;
extern bool alertsNotification = true;
extern bool alertsSound        = false;
extern bool alertsEmail        = false;

double   MAH1[],
         MAL1[],
         MAH2[],
         MAL2[],
         MAH3[],
         MAL3[];

//-------------------------------------------------------------------
//                                                                  
//-------------------------------------------------------------------
//
//
//
//
//

int init()
{
   SetIndexBuffer(0,MAH1);   SetIndexLabel(0,"Hi("+Period1+")");
   SetIndexBuffer(1,MAL1);   SetIndexLabel(1,"Lo("+Period1+")");
   SetIndexBuffer(2,MAH2);   SetIndexLabel(2,"Hi("+Period2+")");
   SetIndexBuffer(3,MAL2);   SetIndexLabel(3,"Lo("+Period2+")");
   SetIndexBuffer(4,MAH3);   SetIndexLabel(4,"Hi("+Period3+")");
   SetIndexBuffer(5,MAL3);   SetIndexLabel(5,"Lo("+Period3+")");
   return(0);
}
void deinit() {}

//-------------------------------------------------------------------
//                                                                  
//-------------------------------------------------------------------
//
//
//
//
//

double trends[][6];
int start()
{
   int i,r,counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         if (ArrayRange(trends,0)!=Bars) ArrayResize(trends,Bars);

   //
   //
   //
   //
   //

   double ke1=2.0/(1.0+Period1);
   double ke2=2.0/(1.0+Period2);
   double ke3=2.0/(1.0+Period3);
   for(i=limit, r=Bars-i-1; i>=0; i--,r++)
   {
      if (i==Bars-1)
      {
         MAH1[i] = High[i]; MAH2[i] = High[i]; MAH3[i] = High[i];
         MAL1[i] = Low[i];  MAL2[i] = Low[i];  MAL3[i] = Low[i];  
         continue;
      }         
      if(High[i]>MAH1[i+1]) { MAH1[i]=High[i]; trends[r][0]=1; } else { MAH1[i]=ke1*High[i]+(1-ke1)*MAH1[i+1]; trends[r][0] = 0; }
      if(High[i]>MAH2[i+1]) { MAH2[i]=High[i]; trends[r][1]=1; } else { MAH2[i]=ke2*High[i]+(1-ke2)*MAH2[i+1]; trends[r][1] = 0; }
      if(High[i]>MAH3[i+1]) { MAH3[i]=High[i]; trends[r][2]=1; } else { MAH3[i]=ke3*High[i]+(1-ke3)*MAH3[i+1]; trends[r][2] = 0; }
      if(Low[i] <MAL1[i+1]) { MAL1[i]=Low[i];  trends[r][3]=1; } else { MAL1[i]=ke1*Low[i] +(1-ke1)*MAL1[i+1]; trends[r][3] = 0; }
      if(Low[i] <MAL2[i+1]) { MAL2[i]=Low[i];  trends[r][4]=1; } else { MAL2[i]=ke2*Low[i] +(1-ke2)*MAL2[i+1]; trends[r][4] = 0; }
      if(Low[i] <MAL3[i+1]) { MAL3[i]=Low[i];  trends[r][5]=1; } else { MAL3[i]=ke3*Low[i] +(1-ke3)*MAL3[i+1]; trends[r][5] = 0; }
   }
   manageAlerts();
   return(0);
}

//-------------------------------------------------------------------
//                                                                  
//-------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; whichBar = Bars-whichBar-1;
      
      //
      //
      //
      //
      //

      if (trends[whichBar][0]!=trends[whichBar-1][0])
      {
         static datetime when1=0;
            if (trends[whichBar][0] == 1) doAlert(when1,"High 1 broken up");
      }
      if (trends[whichBar][1]!=trends[whichBar-1][1])
      {
         static datetime when2=0;
            if (trends[whichBar][1] == 1) doAlert(when2,"High 2 broken up");
      }
      if (trends[whichBar][2]!=trends[whichBar-1][2])
      {
         static datetime when3=0;
            if (trends[whichBar][2] == 1) doAlert(when3,"High 3 broken up");
      }
      if (trends[whichBar][3]!=trends[whichBar-1][3])
      {
         static datetime when4=0;
            if (trends[whichBar][3] == 1) doAlert(when4,"Low 1 broken down");
      }
      if (trends[whichBar][4]!=trends[whichBar-1][4])
      {
         static datetime when5=0;
            if (trends[whichBar][4] == 1) doAlert(when5,"Low 2 broken down");
      }
      if (trends[whichBar][5]!=trends[whichBar-1][5])
      {
         static datetime when6=0;
            if (trends[whichBar][5] == 1) doAlert(when6,"Low 3 broken down");
      }
   }
}

//
//
//
//
//

void doAlert(datetime& previousTime, string doWhat)
{
   string message;
   
   if (previousTime != Time[0]) {
       previousTime  = Time[0];

       //
       //
       //
       //
       //

       message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," SarFBav "+doWhat);
          if (alertsMessage)       Alert(message);
          if (alertsEmail)         SendMail("SarFBav ","SarFBav "+message);
          if (alertsNotification)  SendNotification("SarFBav "+message);
          if (alertsSound)         PlaySound("alert2.wav");
   }
}

